/***
* PRG........: DBF_STK
* MODULE.....: Database stack
* DESC.......: Pushing and popping database attributes
* PREFIX.....: Dstk
* EXPORT.....: DstkPush()
*              DstkPop()
* CONSTRUCTOR: There is no constructor function. We cheat and
*              initialize an external static.
* USES.......:
* NOTES......: Must compile with /n as it uses an external static
*/

#include "set.ch"
#include "assert.ch"
#define LEN_DBF_STK_ENTRY 21

// Character variable used as a stack
STATIC cDbfStk := ""

/***
* DstkPush()
*
* Push an entry on database stack. We save selection area,
* record number, index order, SET SOFTSEEK, and SET DELETED and Alias
*/

FUNCTION Dstk_Push
  cDbfStk := Chr(Select()) + Str(Recno(), 7)    ;
             + Chr(IndexOrd())                   ;
             + Iif(Set(_SET_SOFTSEEK), "T", "F") ;
             + Iif(Set(_SET_DELETED), "T", "F");
             + pad(alias(select()),10)+cDbfStk
RETURN cDbfStk


/***
* DstkPop()
*
* Remove latest entry from database stack (popping it),
* and restore the database attributes
*/

FUNCTION Dstk_Pop

  // Integrity check- -Stack must not be empty
  ASSERT(Len(cDbfStk) > 0)
  Set(_SET_SOFTSEEK, SubStr(cDbfStk, 10, 1) == "T")
  Set(_SET_DELETED,  SubStr(cDbfStk, 11, 1) == "T")

  SELECT (Asc(SubStr(cDbfStk, 1, 1)))
  GOTO Val(SubStr(cDbfStk, 2, 7))
  SET ORDER TO Asc(SubStr(cDbfStk, 9, 1))

  cDbfStk := SubStr(cDbfStk, LEN_DBF_STK_ENTRY + 1)

RETURN cDbfstk

function dstkpush
  dstk_push()
return cDbfStk

function dstkpop
  dstk_pop()
return cDbfStk

function ShowDbfStack
  local i := 1, j := len(cDbfStk)
  do while j != 0  .and. i <= j
    qout("    Alias: "+substr(cDbfStk,i+11,10))
    qout("Work Area: "+str(Asc(substr(cDbfStk,i,1)),2))
    qout("Record No: "+substr(cDbfstk,i+1,7))
    qout("Order  No: "+str(Asc(substr(cDbfStk,i+8,1)),2))
    i += LEN_DBF_STK_ENTRY
  enddo
return NIL
